#ifndef BITBOARD_H_
#define BITBOARD_H_

#include "chessRef.h"

//#define TwoFullRanks (65535)

const BITBOARD R1=0x00000000000000FF;
const BITBOARD R2=R1<<8;
const BITBOARD R3=R2<<8;
const BITBOARD R4=R3<<8;
const BITBOARD R5=R4<<8;
const BITBOARD R6=R5<<8;
const BITBOARD R7=R6<<8;
const BITBOARD R8=R7<<8;
const BITBOARD C1=0x0101010101010101;
const BITBOARD C2=C1<<1;
const BITBOARD C3=C2<<1;
const BITBOARD C4=C3<<1;
const BITBOARD C5=C4<<1;
const BITBOARD C6=C5<<1;
const BITBOARD C7=C6<<1;
const BITBOARD C8=C7<<1;
const BITBOARD Unit=1;


const PIECE InitBoard[64] = {
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
};

/*
const PIECE InitBoard[64] = {
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,bKing,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,bQueen,0,0,0,0,0,
	wPawn,0,0,0,0,0,0,0,
	wKing,wRook,0,0,0,0,0,0
};
*/

BITBOARD rotateRight90(BITBOARD initBoard);
BITBOARD rotateLeft90(BITBOARD initBoard);
BITBOARD rotateRight45(BITBOARD initBoard);
BITBOARD rotateLeft45(BITBOARD initBoard);
BITBOARD reverseRight45(BITBOARD initBoard);
BITBOARD reverseLeft45(BITBOARD initBoard);

void initBitBoard();
void makeFirstPieceTable();
int pickFirst(BITBOARD board);

BITBOARD getHVControl(BITBOARD board, int pos);
BITBOARD getXControl(BITBOARD board, int pos);

#endif //BITBOARD_H_
