// Controller.h: interface for the Controller class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONTROLLER_H__D94A56E3_69E2_4DAA_ABBC_01A7894ACBDD__INCLUDED_)
#define AFX_CONTROLLER_H__D94A56E3_69E2_4DAA_ABBC_01A7894ACBDD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "chessRef.h"
#include "Configuration.h"

class Controller  
{
public:
	Controller();
	virtual ~Controller();

private:
	Configuration* m_pCurConfig;
	Evaluator* m_pEvalOpen;
	Evaluator* m_pEvalMid;
	Evaluator* m_pEvalEnd;

	Evaluator* m_pEvaluator2;
	MoveGen* m_pMoveGen;
	MoveGen* m_pMoveGen2;

public:
	void initialize(); //initialize some objects
	void start(); //join the game

//	Configuration* getCurConfig();

public:
	int plyLimit;
	int nodeLimit;
	bool isTraceOff;
	EvaluationType evalType;
	int ColorAssigned; //true I first, false opponent first
};

#endif // !defined(AFX_CONTROLLER_H__D94A56E3_69E2_4DAA_ABBC_01A7894ACBDD__INCLUDED_)
