// Evaluator.h: interface for the Evaluator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVALUATOR_H__DECA030C_3915_4C41_8708_2BC6C2A93054__INCLUDED_)
#define AFX_EVALUATOR_H__DECA030C_3915_4C41_8708_2BC6C2A93054__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Evaluator;

#include "BitBoard.h"
#include "Configuration.h"

class Evaluator  
{
public:
	Evaluator() {};
	virtual ~Evaluator() {};
public:
	virtual int evaluate(Configuration* config)=0;
protected:
	bool IsWinning(Configuration* conf, bool Blackturn);
	unsigned short PieceBoard[8][8];		//	record the values of pieces on the board
	float k,m,a,b,p,o,e;
protected:
	float King_safety(Configuration* conf, bool Blackturn);
	float King_center(Configuration* conf, bool Blackturn);
	float Opening_rules(Configuration* config, bool Blackturn);
	float Materials(Configuration* conf, bool Blackturn);
	float Attacking(Configuration* conf, bool Blackturn);
	float Board_control(Configuration* conf, bool Blackturn);
	float Pawn_position(Configuration* conf, bool Blackturn);
	float Ending_rules(Configuration* config, bool Blackturn);
};

class Midgame : public Evaluator
{
public:
	Midgame() {};
	virtual ~Midgame() {};
public:
	virtual int evaluate(Configuration* config);
};

class Opening : public Evaluator
{
public:
	Opening() {};
	virtual ~Opening() {};
public:
	virtual int evaluate(Configuration* config);
};

class EndGame : public Evaluator
{
public:
	EndGame() {};
	virtual ~EndGame() {};
public:
	virtual int evaluate(Configuration* config);
};

class Quiescence: public Evaluator
{
public:
	Quiescence() {};
	virtual ~Quiescence() {}
public:
	virtual int evaluate(Configuration* config);
};

#endif // !defined(AFX_EVALUATOR_H__DECA030C_3915_4C41_8708_2BC6C2A93054__INCLUDED_)

