#include "Hash.h"
#include <cstdlib>
#include <ctime>
#include <cassert>

unsigned long HashTableSize;

HashEntry* WHashTable=NULL;
HashEntry* BHashTable=NULL;

unsigned int RandomTable1[64][13]; //used to make key
unsigned int RandomTable2[64][13]; //used to make checknum
unsigned int referTable[39];

unsigned long longRand()
{
	unsigned long longRandom=(unsigned long)rand();
	longRandom<<=16;
	longRandom+=rand();
	return longRandom;
}

void initHash()
{
	//produce random tables
	//unsigned int randSeed=(unsigned int)clock();
	srand(clock());
	int i;
	for(i=0;i<64;i++)
		for(int j=0;j<13;j++)
		{
			RandomTable1[i][j]=longRand();
		}

	for(i=0;i<64;i++)
		for(int j=0;j<13;j++)
		{
			RandomTable2[i][j]=longRand();
		}

	//produce the referTable
	for(i=0;i<39;i++)
	{
		referTable[i]=0;
	}
	referTable[wKing%39]=1;
	referTable[wQueen%39]=2;
	referTable[wBishop%39]=3;
	referTable[wKnight%39]=4;
	referTable[wRook%39]=5;
	referTable[wPawn%39]=6;
	referTable[bKing%39]=7;
	referTable[bQueen%39]=8;
	referTable[bBishop%39]=9;
	referTable[bKnight%39]=10;
	referTable[bRook%39]=11;
	referTable[bPawn%39]=12;

	//initilize hash table
	HashTableSize=HASH_MEM_SIZE/sizeof(HashEntry);

	BHashTable=new HashEntry[HashTableSize];
	assert(BHashTable!=NULL);	
	WHashTable=new HashEntry[HashTableSize];
	assert(WHashTable!=NULL);

	for(i=0;i<HashTableSize;i++)
	{
		BHashTable[i].plyDepth=0;
		WHashTable[i].plyDepth=0;
	}
}
	
void cleanupHash()
{
	if(BHashTable!=NULL)
		delete[] BHashTable;
	if(WHashTable!=NULL)
		delete[] WHashTable;
}

KEY makeKey(Configuration* config)
{
	KEY key=0;
	int index;
	for(int i=0;i<8;i++)
		for(int j=0;j<8;j++)
		{
			index=referTable[config->board[i][j]%39];
			key^=RandomTable1[(i<<3)+j][index];
		}
	return key;
}

KEY makeCheckNum(Configuration* config)
{
	KEY checkNum=0;
	int index;
	for(int i=0;i<8;i++)
		for(int j=0;j<8;j++)
		{
			index=referTable[config->board[i][j]%39];
			checkNum^=(KEY)RandomTable2[(i<<3)+j][index];
		}
	return checkNum;
}

HashEntry* lookup(KEY key, bool blackNext)
{
	//HashEntry* entry=NULL;
	
	unsigned long index;
	index=key%HashTableSize;

	if(blackNext)
	{
		return BHashTable+index;
	}
	else
	{
		return WHashTable+index;
	}
}

