// Message.h: interface for the Message class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MESSAGE_H__A9EA7350_1D05_4E9B_85AB_27868BB3976F__INCLUDED_)
#define AFX_MESSAGE_H__A9EA7350_1D05_4E9B_85AB_27868BB3976F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "chessRef.h"

enum MsgType
{
	INITIALIZE=0,
	SETTING=1,
	NEW=2,
	FORCE=3,
	MOVING=4,
	DRAW=5,
	POST=6,
	QUIT=7,
	PROTOVER=8,
	USELESS=9,
	COLOR=10,
	HARD=11,
	RESIGN=12,
	RESULT=13,
	PROMOTION=14,
	ERROR=15
};

class Message  
{
public:
	Message();
	Message(Message &message);
	Message(MsgType m_type);
	virtual ~Message();
public:
	bool Post;	// the Option to post thinking
	MsgType type; //the type of message
	bool GameMode; //True for Normal, False for Force Mode
	bool Color; //True for white, False for black.
	bool Difficulty; //True for hard, False for easy
	int timeperMove; //Time for each Move.
	int depth; //Ply number 
	PIECE promotionChoice;
	MOVE move;
	int Moves;
	int TotalTime;
	int increTime;
};

#endif // !defined(AFX_MESSAGE_H__A9EA7350_1D05_4E9B_85AB_27868BB3976F__INCLUDED_)
