// MoveGen.h: interface for the MoveGen class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MOVEGEN_H__E4EA45C6_9EDF_4D56_92FA_E5909E9AE1E6__INCLUDED_)
#define AFX_MOVEGEN_H__E4EA45C6_9EDF_4D56_92FA_E5909E9AE1E6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class MoveGen;

//used for store configuration list
#include <list>

#include "chessRef.h"
#include "Configuration.h"

//typedef std::priority_queue<Configuration*, std::vector<Configuration*>, greaterConfig> SuccessorQueue;
//typedef std::stack<Configuration*> SuccessorStack; //used for reverse order


class MoveGen  
{
public:
	MoveGen() {};
	virtual ~MoveGen() {};

public:
	virtual ConfigList* successors(Configuration* config)=0;
};

class MoveGen1 //: public MoveGen
{
public:
	MoveGen1();
	virtual ~MoveGen1();

public:
	virtual MoveList* successors(Configuration* config);
};

class MoveGen2 : public MoveGen
{
public:
	MoveGen2();
	virtual ~MoveGen2();

private:
	MoveGen1* m_pMoveGen;

public:
	virtual ConfigList* successors(Configuration* config);
};

class MoveGen3 //only produce capturing move
{
public:
	MoveGen3();
	virtual ~MoveGen3();

public:
	virtual MoveList* successors(Configuration* config);
};

class MoveGen4 : public MoveGen //using MoveGen3 to produce capturing config
{
public:
	MoveGen4();
	virtual ~MoveGen4();

private:
	MoveGen1* m_pMoveGen;

public:
	virtual ConfigList* successors(Configuration* config);
};

#endif // !defined(AFX_MOVEGEN_H__E4EA45C6_9EDF_4D56_92FA_E5909E9AE1E6__INCLUDED_)
