// Opengame.cpp: implementation of the Opengame class.
//
//////////////////////////////////////////////////////////////////////

#include "Opengame.h"

Opengame openbook[11];

const PIECE boards[66][64]={
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,bPawn,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,bPawn,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,wKnight,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,0,wRook
	},
	{
	bRook,0,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,bKnight,0,0,0,0,0,
	0,0,0,0,bPawn,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,wKnight,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,0,wRook
	},
	{
	bRook,0,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,bKnight,0,0,0,0,0,
	0,wBishop,0,0,bPawn,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,wKnight,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,0,0,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,wPawn,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,bPawn,0,0,0,
	0,0,wPawn,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,bPawn,0,0,0,
	0,0,wPawn,0,0,0,0,0,
	0,0,wKnight,0,0,0,0,0,
	wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,0,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,0,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,bPawn,0,0,0,
	0,bBishop,wPawn,0,0,0,0,0,
	0,0,wKnight,0,0,0,0,0,
	wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,0,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,0,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,bPawn,0,0,0,
	0,bBishop,wPawn,0,0,0,0,0,
	0,0,wKnight,0,0,0,wPawn,0,
	wPawn,wPawn,0,wPawn,wPawn,wPawn,0,wPawn,
	wRook,0,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,bPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,bPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,wPawn,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,0,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,0,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,bPawn,0,0,0,
	0,0,bPawn,0,0,0,0,0,
	0,0,wPawn,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,0,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,0,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,bPawn,0,0,0,
	0,0,bPawn,wPawn,0,0,0,0,
	0,0,wPawn,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,0,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,bKnight,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,bKnight,0,0,
	0,0,0,0,0,0,0,0,
	0,0,wPawn,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,0,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,bPawn,bKnight,0,0,
	0,0,0,0,0,0,0,0,
	0,0,wPawn,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,0,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,bPawn,bKnight,0,0,
	0,0,0,0,0,0,0,0,
	0,0,wPawn,wPawn,0,0,0,0,
	0,0,0,0,0,wKnight,0,0,
	wPawn,wPawn,0,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,0,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,wPawn,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,bKnight,0,0,
	0,0,0,0,0,0,0,0,
	0,0,wPawn,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,bKnight,0,0,
	0,0,0,0,0,0,0,0,
	0,0,wPawn,0,0,0,0,0,
	0,0,wKnight,0,0,0,0,0,
	wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,0,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,0,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,bPawn,0,0,bKnight,0,0,
	0,0,0,0,0,0,0,0,
	0,0,wPawn,0,0,0,0,0,
	0,0,wKnight,0,0,0,0,0,
	wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,0,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,0,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,bPawn,0,0,bKnight,0,0,
	0,0,0,0,0,0,0,0,
	0,0,wPawn,0,wPawn,0,0,0,
	0,0,wKnight,0,0,0,0,0,
	wPawn,wPawn,0,wPawn,0,wPawn,wPawn,wPawn,
	wRook,0,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,bPawn,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,bPawn,0,0,0,
	0,0,wBishop,0,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,0,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,0,bKnight,0,0,
	0,0,0,0,bPawn,0,0,0,
	0,0,wBishop,0,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,0,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,
	0,0,0,0,0,bKnight,0,0,
	0,0,0,0,bPawn,0,0,0,
	0,0,wBishop,wPawn,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,0,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,0,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,wPawn,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,0,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,bPawn,0,0,0,0,
	0,wPawn,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,0,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,bPawn,0,0,0,0,
	0,wPawn,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wBishop,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,0,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,0,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,bPawn,0,0,0,0,
	0,wPawn,0,0,0,0,bBishop,0,
	0,0,0,0,0,0,0,0,
	wPawn,wBishop,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,0,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,0,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,bPawn,0,0,0,0,
	0,wPawn,0,0,0,0,bBishop,0,
	0,0,0,0,0,wKnight,0,0,
	wPawn,wBishop,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,0,wQueen,wKing,wBishop,0,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,bKnight,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,bKnight,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,bKnight,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,0,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,bKnight,wPawn,0,0,0,
	0,0,0,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,0,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,wPawn,0,0,0,0,
	0,0,0,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,0,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,wPawn,0,0,0,0,
	0,0,wPawn,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,0,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,0,0,bPawn,bPawn,bPawn,bPawn,
	0,0,bPawn,0,0,0,0,0,
	0,0,0,wPawn,0,0,0,0,
	0,0,wPawn,wPawn,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,0,0,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,0,0,bPawn,bPawn,bPawn,bPawn,
	0,0,bPawn,0,0,0,0,0,
	0,0,0,wPawn,0,0,0,0,
	0,0,wPawn,wPawn,0,0,0,0,
	0,0,wKnight,0,0,0,0,0,
	wPawn,wPawn,0,0,wPawn,wPawn,wPawn,wPawn,
	wRook,0,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,0,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,bPawn,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,0,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,bPawn,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,
	0,0,0,0,0,wKnight,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,0,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,0,0,bPawn,bPawn,bPawn,bPawn,
	0,0,0,bPawn,0,0,0,0,
	0,0,bPawn,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,
	0,0,0,0,0,wKnight,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,0,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,0,0,bPawn,bPawn,bPawn,bPawn,
	0,0,0,bPawn,0,0,0,0,
	0,wBishop,bPawn,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,
	0,0,0,0,0,wKnight,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,0,0,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,0,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,bPawn,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,0,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,wKnight,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,0,bPawn,bPawn,bPawn,bPawn,bPawn,
	0,0,0,0,0,0,0,0,
	0,0,bPawn,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,wKnight,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,0,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,0,0,bPawn,bPawn,bPawn,bPawn,
	0,0,0,bPawn,0,0,0,0,
	0,0,bPawn,0,0,0,0,0,
	0,0,0,0,wPawn,0,0,0,
	0,0,0,0,0,wKnight,0,0,
	wPawn,wPawn,wPawn,wPawn,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,0,wRook
	},
	{
	bRook,bKnight,bBishop,bQueen,bKing,bBishop,bKnight,bRook,
	bPawn,bPawn,0,0,bPawn,bPawn,bPawn,bPawn,
	0,0,0,bPawn,0,0,0,0,
	0,0,bPawn,0,0,0,0,0,
	0,0,0,wPawn,wPawn,0,0,0,
	0,0,0,0,0,wKnight,0,0,
	wPawn,wPawn,wPawn,0,0,wPawn,wPawn,wPawn,
	wRook,wKnight,wBishop,wQueen,wKing,wBishop,0,wRook
	}
};

const bool blacks[11][6]={
	false,true,false,true,false,true,
	false,true,false,true,false,true,
	false,true,false,true,false,true,
	false,true,false,true,false,true,
	false,true,false,true,false,true,
	false,true,false,true,false,true,
	false,true,false,true,false,true,
	false,true,false,true,false,true,
	false,true,false,true,false,true,
	false,true,false,true,false,true,
	false,true,false,true,false,true
};

const MOVE moves[11][6]={
	(MOVE)((52<<8)+36),(MOVE)((12<<8)+28),(MOVE)((62<<8)+45),(MOVE)((1<<8)+18),(MOVE)((61<<8)+25),(MOVE)((8<<8)+16),
	(MOVE)((50<8)+34),(MOVE)((12<<8)+28),(MOVE)((57<<8)+42),(MOVE)((5<<8)+33),(MOVE)((54<<8)+46),(MOVE)((33<<8)+42),
	(MOVE)((51<8)+35),(MOVE)((12<<8)+20),(MOVE)((50<<8)+34),(MOVE)((10<<8)+26),(MOVE)((35<<8)+27),(MOVE)((28<<8)+35),
	(MOVE)((51<<8)+35),(MOVE)((6<<8)+21),(MOVE)((50<<8)+34),(MOVE)((12<<8)+20),(MOVE)((62<<8)+45),(MOVE)((9<<8)+17),
	(MOVE)((50<<8)+34),(MOVE)((6<<8)+21),(MOVE)((57<<8)+42),(MOVE)((10<<8)+18),(MOVE)((52<<8)+36),(MOVE)((11<<8)+27),
	(MOVE)((52<<8)+36),(MOVE)((12<<8)+28),(MOVE)((61<<8)+34),(MOVE)((6<<8)+21),(MOVE)((51<<8)+35),(MOVE)((28<<8)+35),
	(MOVE)((49<<8)+33),(MOVE)((11<<8)+27),(MOVE)((58<<8)+49),(MOVE)((2<<8)+38),(MOVE)((62<<8)+45),(MOVE)((1<<8)+11),
	(MOVE)((52<<8)+36),(MOVE)((6<<8)+21),(MOVE)((36<<8)+28),(MOVE)((21<<8)+27),(MOVE)((51<<8)+35),(MOVE)((11<<8)+19),
	(MOVE)((51<<8)+35),(MOVE)((11<<8)+27),(MOVE)((50<<8)+34),(MOVE)((10<<8)+18),(MOVE)((57<<8)+42),(MOVE)((6<<8)+21),
	(MOVE)((52<<8)+36),(MOVE)((10<<8)+26),(MOVE)((62<<8)+45),(MOVE)((11<<8)+19),(MOVE)((61<<8)+25),(MOVE)((1<<8)+18),
	(MOVE)((52<<8)+36),(MOVE)((10<<8)+26),(MOVE)((62<<8)+45),(MOVE)((11<<8)+19),(MOVE)((51<<8)+35),(MOVE)((26<<8)+35),
};


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Opengame::Opengame()
{
}

Opengame::~Opengame()
{
}

bool Opengame::Search(Config *s)
{
	int findit=1;
	int order=-1;
	for( int i=0; i<6; i++)
	{
		findit=1;
		for( int j=0; j<8; j++)
			for( int k=0; k<8; k++)
			{
				if( s->board[j][k]!=confs[i].board[j][k])
					findit=0;
			}
		if(findit&&confs[i].blackNext==s->blackNext)
		{
			order=i;// We have found it.
		}
	}
	if( order!=-1)
	{
		s->move=confs[order].move;
		return true;
	}
	return false;
}


void initOpenbook()
{
	int i, j, k,m;
	for(i=0;i<11;i++)
		for(j=0;j<6;j++)
		{
			for(k=0;k<8;k++)
				for(m=0;m<8;m++)
					openbook[i].confs[j].board[k][m]=boards[6*i+j][k*8+m];
			openbook[i].confs[j].blackNext=blacks[i][j];
			openbook[i].confs[j].move=moves[i][j];
		}
}

