// Parser.cpp: implementation of the Parser class.
//
//////////////////////////////////////////////////////////////////////

#include "Parser.h"
#include <cstring>
#include <cmath>
#include <iostream>
#include <fstream>

using namespace std ;

///////////////////////////////
// Global Function 
//////////////////////////////




//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Parser::Parser()
{
}

Parser::~Parser()
{
}

void Parser::getMessage(Message *InputMessage)
{
//	Read from Input
	char inputLine[80];
	char inputParameter[10];
	int i,j;
	int inputNumber;
	int inputPara1,inputPara2;
    cin>> inputLine;


	ofstream traceout("chess_trace.txt", ios::app);
//  For Debug only
	traceout << "SERVER" << inputLine << endl;

//	for(i=0; i<strlen((char *)inputLine);i++)
//		inputLine[i]=tolower(inputLine[i]);

// Parsing the Input Command
	// Initialization Message
	
    if ( !strncmp(inputLine,"xboard",strlen("xboard"))) 
		InputMessage->type=INITIALIZE;

	// Then send Feature back.
    else if( !strncmp(inputLine,"protover",strlen("protover"))) 
	{
		cin >> inputNumber; 
//  For Debug only
		traceout << inputNumber << endl;

		if( inputNumber==2 )
			InputMessage->type=PROTOVER;
	}

	// New Game
	else if( !strncmp(inputLine, "new",strlen("new")))
		InputMessage->type=NEW;
	
	// Offer Draw
	else if( !strncmp(inputLine, "draw",strlen("draw")))
		InputMessage->type=DRAW;

	// Quit Game
	else if( !strncmp(inputLine, "quit",strlen("quit")))
		InputMessage->type=QUIT;

	// Settings 
	else if( !strncmp(inputLine, "force",strlen("force")))
	{
		InputMessage->type=FORCE;
		InputMessage->GameMode=false;
	}

	else if( !strncmp(inputLine, "go",strlen("go")))
	{
		InputMessage->type=FORCE;
		InputMessage->GameMode=true;
	}

	else if( !strncmp(inputLine, "white",strlen("white")))
	{
		InputMessage->type=COLOR;
		InputMessage->Color=true;
	}

	else if( !strncmp(inputLine, "black",strlen("black")))
	{
		InputMessage->type=COLOR;
		InputMessage->Color=false;
	}

	else if( !strncmp(inputLine, "hard",strlen("hard")))
	{
		InputMessage->type=HARD;
		InputMessage->Difficulty=true;
	}

	else if( !strncmp(inputLine, "easy",strlen("easy")))
	{
		InputMessage->type=HARD;
		InputMessage->Difficulty=false;
	}

	else if( !strncmp(inputLine,"post",strlen("post"))) 
	{
		InputMessage->type=POST;
		InputMessage->Post=true;
	}

	else if( !strncmp(inputLine,"nopost",strlen("nopost"))) 
	{
		InputMessage->type=POST;
		InputMessage->Post=false;
	}

	else if( !strncmp(inputLine,"st",strlen("st"))) 
	{
		cin >> inputNumber;
		//  For Debug only
		traceout << inputNumber << endl;
		InputMessage->type=SETTING;
		InputMessage->timeperMove=inputNumber;
	}

	else if( !strncmp(inputLine,"sd",strlen("sd"))) 
	{
		cin >> inputNumber;
		//  For Debug only
		traceout << inputNumber << endl;

		InputMessage->type=USELESS;
		InputMessage->depth=inputNumber;
	}
	
	// UnImplemented
	else if( !strncmp(inputLine, "computer",strlen("computer")))
		InputMessage->type=USELESS;

	else if( !strncmp(inputLine, "random",strlen("random")))
		InputMessage->type=USELESS;

	else if( !strncmp(inputLine, "accepted",strlen("accepted")))
	{
		cin >> inputParameter;
	// Debug Only
		traceout << inputParameter << endl;
		InputMessage->type=USELESS;
	}


	else if( !strncmp(inputLine, "rejected",strlen("rejected")))
	{
		cin >> inputParameter;
		traceout << inputParameter << endl;
		InputMessage->type=USELESS;
	}

	else if( !strncmp(inputLine, "playother",strlen("playother")))
		InputMessage->type=USELESS;
	
	else if( !strncmp(inputLine, "?",strlen("?")))
		InputMessage->type=USELESS;
	
	else if( !strncmp(inputLine, "hint",strlen("hint")))
		InputMessage->type=USELESS;

	else if( !strncmp(inputLine, "bk",strlen("bk")))
		InputMessage->type=USELESS;

	else if( !strncmp(inputLine, "undo",strlen("undo")))
		InputMessage->type=USELESS;

	else if( !strncmp(inputLine, "remove",strlen("remove")))
		InputMessage->type=USELESS;

	else if( !strncmp(inputLine, "analyze",strlen("analyze")))
		InputMessage->type=USELESS;
	
	else if( !strncmp(inputLine, "pause",strlen("pause")))
		InputMessage->type=USELESS;

	else if( !strncmp(inputLine, "resume",strlen("resume")))
		InputMessage->type=USELESS;

	else if( !strncmp(inputLine,"time",strlen("time"))) 
	{
		cin >> inputNumber;
		//  For Debug only
		traceout << inputNumber << endl;

		InputMessage->type=USELESS;
	}

	else if( !strncmp(inputLine,"otim",strlen("otim"))) 
	{
		cin >> inputNumber;
		//  For Debug only
		traceout << inputNumber << endl;

		InputMessage->type=USELESS;
	}

	else if( !strncmp(inputLine,"name",strlen("name"))) 
	{
		cin >> inputLine;
		//  For Debug only
		traceout << inputLine << endl;

		InputMessage->type=USELESS;
	}
	
	else if( !strncmp(inputLine,"edit",strlen("edit"))) 
	{
		InputMessage->type=USELESS;
	}

	else if( !strncmp(inputLine,"rating",strlen("rating"))) 
	{
		cin >> inputPara1;
		cin >> inputPara2;
		InputMessage->type=USELESS;
	}

	else if( !strncmp(inputLine,"edit",strlen("edit"))) 
	{
		InputMessage->type=USELESS;
	}

	else if( !strncmp(inputLine,"level",strlen("level"))) 
	{
		cin >> inputPara1;
		cin >> inputParameter;
		cin >> inputPara2;

		if ( inputPara2==0)  //Conventional Timer
		{
			InputMessage->Moves=inputPara1;
			// Processing the Times now.
			int flag=0;
			int pos;
			for( i=0; i<strlen(inputParameter); i++)
				if( inputParameter[i]==':')
				{
					flag=1;
					pos=i;
				}
			if( flag)
			{
				for( i=0; i<pos; i++)
					InputMessage->TotalTime+=(inputParameter[i]-'0')*(pow(10,(pos-1-i)));
				InputMessage->TotalTime*=60;
				for( i=pos+1;i<strlen(inputParameter);i++)
					InputMessage->TotalTime+=(inputParameter[i]-'0')*(pow(10,(strlen(inputParameter)-i-1)));
			}
			else 
			{
				for( i=0; i<strlen(inputParameter); i++)
					InputMessage->TotalTime+=(inputParameter[i]-'0')*(pow(10,(strlen(inputParameter)-i-1)));
				InputMessage->TotalTime*=60;
			}
			
		}
		else 
		{
			int flag=0;
			int pos;
			for( i=0; i<strlen(inputParameter); i++)
				if( inputParameter[i]==':')
				{
					flag=1;
					pos=i;
				}
			if( flag)
			{
				for( i=0; i<pos; i++)
					InputMessage->TotalTime+=(inputParameter[i]-'0')*(pow(10,(pos-1-i)));
				InputMessage->TotalTime*=60;
				for( i=pos+1;i<strlen(inputParameter);i++)
					InputMessage->TotalTime+=(inputParameter[i]-'0')*(pow(10,(strlen(inputParameter)-i-1)));
			}
			else 
			{
				for( i=0; i<strlen(inputParameter); i++)
					InputMessage->TotalTime+=(inputParameter[i]-'0')*(pow(10,(strlen(inputParameter)-i-1)));
				InputMessage->TotalTime*=60;
			}
			InputMessage->increTime=inputPara2;
		}
		
		traceout << inputPara1 << inputParameter << inputPara2;
		// Need to add operation here.
		InputMessage->type=SETTING;
	}

	else if( !strncmp(inputLine,"usermove",strlen("usermove"))) 
	{
		cin >> inputParameter;
		//  For Debug only
		traceout << inputParameter << endl;

		InputMessage->type=MOVING;
		i=inputParameter[0]-'a';
		j=inputParameter[1]-'1';
		int from=8*(7-j)+i;
		i=inputParameter[2]-'a';
		j=inputParameter[3]-'1';
		int to=8*(7-j)+i;
		// this is to detect promotion.
		// Need to add more here.
		if (strlen(inputParameter)==5)
		{
			char promotion=inputParameter[4];
			InputMessage->type=PROMOTION;
			if ( promotion == 'q') // So it's queen.
				InputMessage->promotionChoice= 0x20;
			else if ( promotion == 'b')  // Bishop
				InputMessage->promotionChoice= 0x10;
			else if ( promotion == 'k')  // Knight
				InputMessage->promotionChoice= 0x08;
			else if ( promotion == 'r')  // Rook
				InputMessage->promotionChoice= 0x04;
		}
		InputMessage->move=(MOVE)((from<<8)+to);
	}

	else if( !strncmp(inputLine,"result",strlen("result"))) 
	{
		cin >> inputParameter;
		cin >> inputLine;
		// Need to add operation here.
		InputMessage->type=RESULT;
	}
	
	else 
	{
		InputMessage->type=ERROR;
	}

}


