// Reporter.cpp: implementation of the Reporter class.
//
//////////////////////////////////////////////////////////////////////

#include "Reporter.h"
#include <cstring>
#include <iostream>
#include <fstream>

using namespace std ;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Reporter::Reporter()
{

}

Reporter::~Reporter()
{

}

void Reporter::sendMessage(Message *OutputMessage)
{
	int i,j;
	ofstream traceout("chess_trace.txt", ios::app);

	//First, Reply to Server
	if( OutputMessage->type==PROTOVER)
	{
	    cout << "feature usermove=1 playother=0 ping=0 sigint=0 sigterm=0 time=0 variants=\"normal\"" << endl;
		//  For Debug only
		traceout << "feature usermove=1 playother=0 ping=0 sigint=0 sigterm=0 time=1 variants=\"normal\"" << endl;
		traceout << "feature san=0 reuse=0 colors=0 ics=0 pause=0 name=0 myname=\"LTK\" analyze=0 done=1" << endl;	
		
		cout << "feature san=0 reuse=0 colors=0 ics=0 pause=0 name=0 myname=\"LTK\" analyze=0 done=1" << endl;
	}

	else if( OutputMessage->type==INITIALIZE)
	{
		cout << endl;
	}

	else if( OutputMessage->type==MOVING)
	{
		// Need to Implement here.
		i=(int)((OutputMessage->move)>>8);
		j=(int)((OutputMessage->move)&255);
		char a=i%8+'a';
		char b=(7-i/8)+'1';
		char c=j%8+'a';
		char d=(7-j/8)+'1';

		cout << "move " << a << b << c << d << endl;
		traceout << "move " << a << b << c << d << endl;
	}

	else if( OutputMessage->type==RESIGN)
		cout << "resign" << endl;

	else if( OutputMessage->type==ERROR)
	{
		// Need to Implement here.
		cout << "Error " << endl;

	}
	
	else if( OutputMessage->type==RESULT)
	{
		// Need to Implement here.
		cout << "RESULT " << endl;
	}

	else if( OutputMessage->type==DRAW)
		cout << "offer draw" << endl;

	else if( OutputMessage->type==POST)
	{
		// Need to Implement here.
		cout << "ply, score, time, nodes, PV" << endl;
	}

	else if( OutputMessage->type==PROMOTION)
	{
		i=(int)((OutputMessage->move)>>8);
		j=(int)((OutputMessage->move)&255);
		char a=i%8+'a';
		char b=(7-i/8)+'1';
		char c=j%8+'a';
		char d=(7-j/8)+'1';
		char p;
		
		if (OutputMessage->promotionChoice== 0x20)
			p='q';
		if (OutputMessage->promotionChoice== 0x10)
			p='b';
		if (OutputMessage->promotionChoice== 0x08)
			p='k';
		if (OutputMessage->promotionChoice== 0x04)
			p='r';
	
		cout << "move " << a << b << c << d << p << endl;
		traceout << "move " << a << b << c << d << p << endl;

	}
		
}
