#ifndef CHESSREF_H_
#define CHESSREF_H_

#ifdef _MSC_VER
#define _unsigned_64 unsigned __int64
#else
#define _unsigned_64 long long int
#endif

#ifdef _MSC_VER
#define _unsigned_16 short
#else
#define _unsigned_16 short
#endif

typedef _unsigned_64 BITBOARD;
typedef _unsigned_16 MOVE;
typedef unsigned char PIECE;
typedef unsigned long KEY; //used for hash table

//define the chessmen
#define wKing	(PIECE)0x40 //01000000b
#define wQueen	(PIECE)0x20 //00100000b
#define wBishop (PIECE)0x10 //00010000b
#define wKnight (PIECE)0x08 //00001000b
#define wRook	(PIECE)0x04 //00000100b
#define wPawn	(PIECE)0x02 //00000010b
#define bKing	(PIECE)0xC0 //11000000b
#define bQueen	(PIECE)0xA0 //10100000b
#define bBishop (PIECE)0x90 //10010000b
#define bKnight (PIECE)0x88 //10001000b
#define bRook	(PIECE)0x84 //10000100b
#define bPawn	(PIECE)0x82 //10000010b 

//define the values of pieces
#define MaxValue	(unsigned char)255
#define KingValue	(unsigned char)100
#define QueenValue	(unsigned char)9
#define RookValue	(unsigned char)5
#define BishopValue	(unsigned char)3
#define KnightValue	(unsigned char)3
#define PawnValue	(unsigned char)1

#define openMaxStep 40
#define MaxEvalValue 20000
#define MinEvalValue -20000
/* Enumerated board squares */
#define a8 (0)
#define b8 (1)
#define c8 (2)
#define d8 (3)
#define e8 (4)
#define f8 (5)
#define g8 (6)
#define h8 (7)
#define a7 (8)
#define b7 (9)
#define c7 (10)
#define d7 (11)
#define e7 (12)
#define f7 (13)
#define g7 (14)
#define h7 (15)
#define a6 (16)
#define b6 (17)
#define c6 (18)
#define d6 (19)
#define e6 (20)
#define f6 (21)
#define g6 (22)
#define h6 (23)
#define a5 (24)
#define b5 (25)
#define c5 (26)
#define d5 (27)
#define e5 (28)
#define f5 (29)
#define g5 (30)
#define h5 (31)
#define a4 (32)
#define b4 (33)
#define c4 (34)
#define d4 (35)
#define e4 (36)
#define f4 (37)
#define g4 (38)
#define h4 (39)
#define a3 (40)
#define b3 (41)
#define c3 (42)
#define d3 (43)
#define e3 (44)
#define f3 (45)
#define g3 (46)
#define h3 (47)
#define a2 (48)
#define b2 (49)
#define c2 (50)
#define d2 (51)
#define e2 (52)
#define f2 (53)
#define g2 (54)
#define h2 (55)
#define a1 (56)
#define b1 (57)
#define c1 (58)
#define d1 (59)
#define e1 (60)
#define f1 (61)
#define g1 (62)
#define h1 (63)

enum EvaluationType
{
	MIDGAME=0
};

#define SelectNumber 12 //the SelectNumber for usual move
#define SelectNumber2 8 //the Select Number for secondrary search

//#define DEBUG
//#define DEBUG2
#define QUIESCENCE
#define USINGTIMER
//#define USINGHASH
#define OPENBOOK

#endif //CHESSREF_H_
